:- ensure_loaded( '../run' ).
:- ensure_loaded( 'src/llhood/lhood_canonical_uai01' ).
:- ensure_loaded( '../auxil/create_graphs' ).
:- ensure_loaded( '../auxil/create_mvisits' ).
:- ensure_loaded( 'auxil/create_counts' ).
:- ensure_loaded( 'auxil/create_blankets' ).

data_format(data(_,_,_,_,_,_,_,_)).
possible_values( _, [0,1] ).

% :- bb_put( sr, off ).

run_graphs :-
	Runs = [
          model_type(bn),
		runs_file(runs_test),
		print( [24,28,29] ), % defaults currently
		progress('.',5),
		results_dir(out_graphs)
		],
	run( Runs ).
