
% expects 

/* when used by postprocessing auxils. 
:- ensure_loaded( '../../../src/lib/mcmcms_top_dir' ).
:- ensure_loaded( '../../../src/lib/elm' ).
*/

% 2005bb16: following should be elm(...).
/* ok, delete this now
:- bb_get( mcmcms_top_dir, Dir ),
   atom_concat( Dir, '/bns/src/llhood/logamma', Lgamma ),
   ensure_loaded( Lgamma ).
   */
:- prolog_load_context(directory,Dir),
   atom_concat( Dir, '/', DirSl ),
   bb_put( idsd_directory, DirSl ).
:- elm( 'bns/src/llhood/logamma' ).
:- elm( 'carts/data/data_to_feature_pairs' ).
:- elm( 'auxil/dset_has_nofeatures' ).

:- requires( werr/2 ).

idsd_fprs( DataSet ) :-
     idsd_fprs( DataSet, _Ids, _Lim ).

idsd_fprs( DataSet, Ids, Lim ) :-
     % write( splits(Splits)-ids(Ids) ), nl,
	bb_get( idsd_directory, DataDir ),
	atom_concat( DataDir, DataSet, FullDataSet ),
     % NofF is no longer needed,....
	dset_has_nofeatures( FullDataSet, NofF ),
	idsd_fprs( NofF, DataSet, Ids, Lim ).

idsd_fprs( NofF, DataSet, Ids, Lim ) :-
	( bb_get(idsd_put,t(NofF,DataSet,Lim,Ids)) ->
		true
		;
		% NofArgs is NofF + 1,
		bb_get( idsd_directory, DataDir ),
		atom_concat( DataDir, DataSet, FullDataSet ),
		werr( reading( FullDataSet ), info ),
		% write( user_error, reading( FullDataSet ) ), nl( user_error ),
          atom_concat( FullDataSet, '.pl', PlDataSet ),
		read_data_terms( PlDataSet, Data ),
		data_to_feature_pairs( Data, FullDataSet, _Splits, Ids, Lim ),
          Ids = ids(_,Length),
          werr( done_with_the_splits:nof_ids(Length), info ),
		bb_put( idsd_put, t(NofF,DataSet,Lim,Ids) )
	).

data_call_and_feature_list( 0, KatPos, Call, FList, Var ) :-
	!,
	arg( KatPos, Call, Var ),
	FList = [].
data_call_and_feature_list( FromKat, KatPos, Call, [Hv|TVs], Kat ) :-
	Idx is KatPos - FromKat,
	arg( Idx, Call, Hv ),
	NxtFrom is FromKat - 1,
	data_call_and_feature_list( NxtFrom, KatPos, Call, TVs, Kat ).

free_vars_feature_list( 0, [] ) :- !.
free_vars_feature_list( I, [_H|T] ) :-
     NxI is I - 1,
     free_vars_feature_list( NxI, T ).

read_data_terms( File, Data ) :-
     open( File, read, In ),
     read( In, First ),
     read_data_terms_stream( First, In, Data ),
     close( In ).

read_data_terms_stream( end_of_file, _In, [] ) :- !.
read_data_terms_stream( data(List,Kat), In, [List-Kat|T] ) :-
     !,
     read( In, Next ),
     read_data_terms_stream( Next, In, T ).
read_data_terms_stream( Datum, In, [List-Kat|T] ) :-
     Datum =.. [data|Args],
     append( List, [Kat], Args ),
     read( In, Next ),
     read_data_terms_stream( Next, In, T ).
