% comparison_data(LossF,TrueM,DataSize,ModSpace,BStg,RunLgth,Prior,Lkhood,SeedId,StrGoal).

:- ensure_loaded( 'list_of_first_n_nats' ). % 3.

comparison_data( 
				[loss_01,loss_eg_01,loss_ck,loss_ks,loss_naive_edgecount],
				insurance,
				1000,
				rm,
				uc,
				250000,
				'slps/stepped.slp',
				'../bns/src/llhood/lhood_canonical_bdeu_multi_spl.pl',
				% 103, % saemus
				% 451, % pc266
				772, % minotaur
				none,
				[],
				bn/[Nats,[2,3,17,5]]
			) :-
 	list_of_first_n_nats( 27, [], Nats ).

model_id( insurance, sc ).

prior_id( 'bn_or_pick_unif.slp', ou ).
prior_id( 'stepped.slp', pd ).

lhood_id( '../bns/src/llhood/lhood_canonical_uai01.pl', ua ).
lhood_id( '../bns/src/llhood/lhood_canonical_bdeu_multi_spl.pl', lr ).
