:- ensure_loaded( '../compare' ).			% compare_defaults/1.
:- ensure_loaded( library(system) ).		% /1, working_directory/2.

test_all( _ ) :-
	working_directory( _Old, '..' ), 
	working_directory( Here, Here ),
	once( compare_defaults(Defs) ), 
	memberchk( res(Res), Defs ),
	atom_concat( 'mv ', Res, MvRes ),
	atom_concat( Res, '_', ResUns ),
	atom_concat( ' ', ResUns, SpcRes ),
	atom_concat( MvRes, SpcRes, MvPfx ),

	member( Bn, [asia,alarm,insurance,hailfinder] ),
	write( starting(Bn) ), nl,
	atom_concat( 'upsh compare data=atm=cdata/simple_', Bn, Upsh ),
	system( Upsh ),
	working_directory( Here, Res ),
	system( './script' ),
	working_directory( _, Here ),
	atom_concat( MvPfx, Bn, Mv ), 
	system( Mv ),
	write( mv(Mv) ), nl,
	write( done(Bn) ), nl, fail.
