:- ensure_loaded( '../../cdata/slp_has' ).

rec_pa_less( [] ).
rec_pa_less( [H|T] ) :-
	slp_has( H, _, HPaLess ),
	( atom_concat(Stem,'.slp',H) -> true; Stem = H ),
	atom_concat( Stem, '_pa_less.pl', PaLess ),
	open( PaLess, write, Out ),
	rec_pa_less_for( HPaLess, Out ),
	close( Out ),
	rec_pa_less( T ).

rec_pa_less_for( [], _Out ).
rec_pa_less_for( [H|T], Out ) :-
	writeq( Out, parentless(H) ), 
	write( Out, '.' ), nl( Out ),
	rec_pa_less_for( T, Out ).
