:- ensure_loaded( library(ugraphs) ).		%.
:- ensure_loaded( library(ordsets) ).		%.

ancestor_of( Desc, Ped, Anc ) :-
	reachable( Anc, Ped, Descendants ),
	ord_member( Desc, Descendants ).

test1 :- 
	ancestor_of( child1, [child1-[tsarina],child2-[child3],child3-[child1],tsar-[child1],tsarina-[child1,tsar]], tsarina ).

test2 :- 
	ancestor_of( tsarina, [child1-[tsarina],child2-[child3],child3-[child1],tsar-[child1],tsarina-[child1,tsar]], child1 ).
